<template>
  <div id="quotaManagement" class="container">
    <b-row>
      <b-col>
        <!-- Quota Management -->
        <CoscineHeadline :headline="$t('page.quota.headline')" />

        <!-- Dropdowns Row -->
        <b-row>
          <!-- Project Dropdown -->
          <b-col>
            {{ $t("page.quota.projectLabel") }}
            <b-form-select
              :options="projects"
              value-field="id"
              text-field="displayName"
              :disabled="true"
              :model-value="project ? project.id : null"
            >
              <template #first>
                <b-form-select-option :value="null" disabled>
                  {{ $t("page.quota.emptyProjectSelect") }}
                </b-form-select-option>
              </template>
            </b-form-select>
          </b-col>

          <!-- Resource Type Dropdown -->
          <b-col>
            {{ $t("page.quota.resourceTypeLabel") }}
            <b-form-select
              ref="resourceTypeSelect"
              v-model="selectedResourceTypeId"
              :options="resourceTypesInformation"
              value-field="id"
              text-field="iDisplayName"
              :disabled="
                !selectedResourceTypeInformation ||
                selectedQuotas?.totalReserved?.value === undefined
              "
            >
              <template #first>
                <b-form-select-option :value="null" disabled>
                  {{ $t("page.quota.emptyResourceTypeSelect") }}
                </b-form-select-option>
              </template>
            </b-form-select>
          </b-col>
        </b-row>

        <!-- Project Quota Slider -->
        <div class="my-3">
          {{ $t("page.quota.projectQuotaSliderLabel") }}
          <b-placeholder
            v-if="
              !selectedResourceTypeInformation ||
              selectedQuotas?.totalReserved?.value === undefined
            "
            size="lg"
            type="input"
          />
          <b-input-group v-else class="flex-nowrap">
            <!-- Project Quota Allocated Text -->
            <template #prepend>
              <b-input-group-text
                v-b-popover.hover.focus.bottom="
                  $t('page.quota.projectQuotaAllocatedPopover', {
                    resourceType: selectedResourceTypeInformation.iDisplayName,
                  })
                "
              >
                <span class="font-weight-bold">
                  {{
                    $t("page.quota.rangeText", {
                      allocated: toGiB(selectedQuotas?.allocated),
                    })
                  }}
                </span>
              </b-input-group-text>
              <!-- Project Quota Minimum -->
              <b-input-group-text
                v-if="selectedQuotas?.totalReserved"
                v-b-popover.hover.focus.top="
                  $t('page.quota.projectQuotaMinimumPopover', {
                    resourceType: selectedResourceTypeInformation.iDisplayName,
                  })
                "
              >
                {{
                  $t("page.quota.gb", {
                    number: Math.max(toGiB(selectedQuotas.totalReserved), 1),
                  })
                }}
              </b-input-group-text>
            </template>
            <!-- v-model unit must be GiB -->
            <b-form-input
              v-if="selectedQuotas?.allocated"
              id="projectQuotaSlider"
              v-model="selectedQuotas.allocated.value"
              type="range"
              :min="Math.max(toGiB(selectedQuotas.totalReserved), 1)"
              :max="toGiB(selectedQuotas.maximum)"
              :disabled="
                isGuest ||
                isMember ||
                storingQuota ||
                (selectedResourceTypeInformation &&
                  !selectedResourceTypeInformation.isQuotaAdjustable)
              "
              @change="updateResourceTypeProjectQuota"
            />
            <!-- Project Quota Maximum -->
            <template #append>
              <b-input-group-text
                v-b-popover.hover.focus.top="
                  $t('page.quota.projectQuotaMaximumPopover', {
                    resourceType: selectedResourceTypeInformation.iDisplayName,
                  })
                "
              >
                <span>
                  {{
                    $t("page.quota.gb", {
                      number: toGiB(selectedQuotas?.maximum),
                    })
                  }}
                </span>
              </b-input-group-text>
            </template>
          </b-input-group>
        </div>

        <!-- Request More Quota Button -->
        <b-row>
          <b-col>
            <b-button
              class="float-end"
              variant="primary"
              :href="$t('page.quota.moreHelpLink')"
              target="_blank"
              :disabled="isGuest || isMember"
            >
              {{ $t("page.quota.moreHelp") }}
            </b-button>
          </b-col>
        </b-row>

        <div class="h-divider my-3" />

        <!-- Resources -->
        <CoscineHeadline :headline="$t('page.quota.resources')" />

        <!-- Resources Table -->
        <b-table
          :fields="resourceQuotaTableFields"
          :items="resourceQuotas"
          :busy="
            loadingData &&
            selectedResourceTypeId !== null &&
            selectedResourceTypeId.trim() !== ''
          "
          :sort-by="[{ key: 'name', order: 'desc' }]"
          show-empty
          sticky-header="100%"
          no-border-collapse
          responsive
          class="mt-3"
          :empty-text="
            selectedResourceTypeId !== ''
              ? $t('page.quota.emptyTableText')
              : $t('page.quota.noResourceTypeChoosen')
          "
        >
          <!-- Adjust Quota Column Header -->
          <template #head(adjust)>
            <span>{{ $t("page.quota.adjustQuota") }}</span>
          </template>

          <!-- Resource Name Cell Contents  -->
          <template #cell(name)="data">
            {{
              resources?.find((r) => r.id === data.item.resource?.id)
                ?.displayName
            }}
            <b-badge
              v-if="isArchived(data.item.resource?.id)"
              pill
              variant="warning"
              class="ms-3"
            >
              {{ $t("default.archived") }}
            </b-badge>
          </template>

          <!-- Reserved Cell Contents  -->
          <template #cell(reserved)="data">
            {{ $t("page.quota.gb", { number: data.item.reserved?.value }) }}
          </template>

          <!-- Used Cell Contents -->
          <template #cell(used)="data">
            <span
              v-b-popover.hover.right="
                $t('page.quota.formatUsed', {
                  quota: formatUsed(data.item.used),
                })
              "
            >
              {{
                `${Math.ceil((data.item.usedPercentage ?? 0) * 100) / 100} %`
              }}
            </span>
          </template>

          <!-- Adjust Quota Slider Contents -->
          <template #cell(adjust)="data">
            <div class="rangeVisual">
              <!-- Resource Quota Minimum -->
              <span
                v-b-popover.hover.left="{
                  boundary: 'window',
                  content: $t('page.quota.resourceQuotaMinimumPopover'),
                }"
              >
                {{
                  $t("page.quota.gb", {
                    number: minGiB(data.item.resource?.id),
                  })
                }}
              </span>
              <!-- Resource Quota Slider -->
              <b-form-input
                v-if="data.item.reserved"
                :id="'resourceQuotaSlider-' + data.item.resource?.id"
                v-model="data.item.reserved.value"
                class="resourceQuotaSlider ml-1"
                type="range"
                :min="minGiB(data.item.resource?.id)"
                :max="maxGiB(data.item.resource?.id)"
                :disabled="
                  isGuest ||
                  isMember ||
                  storingQuota ||
                  isArchived(data.item.resource?.id)
                "
                @change="updateResourceQuota(data.item)"
              />
              <!-- Resource Quota Maximum -->
              <span
                v-b-popover.hover.right="{
                  boundary: 'window',
                  content: $t('page.quota.resourceQuotaMaximumPopover'),
                }"
                class="ml-1"
              >
                {{
                  $t("page.quota.gb", {
                    number: maxGiB(data.item.resource?.id),
                  })
                }}
              </span>
            </div>
          </template>

          <!-- Table Loading -->
          <template #table-busy>
            <div class="text-center text-danger my-2">
              <b-spinner class="align-middle" />
              <strong class="ms-2">{{ $t("default.loading") }}</strong>
            </div>
          </template>
        </b-table>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts">
// import the store for current module
import useProjectStore from "../store";
import useResourceStore from "@/modules/resource/store";

import useNotificationStore from "@/store/notification";
import { FileUtil } from "@/modules/resource/utils/FileUtil";

import type {
  ProjectDto,
  ProjectQuotaDto,
  ProjectQuotaForUpdateDto,
  QuotaDto,
  QuotaForManipulationDto,
  ResourceDto,
  ResourceQuotaDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import {
  CoscineResourceTypes,
  ExtendedResourceTypeInformationDto,
  QuotaUnit,
} from "@/modules/resource/types";
import type { VisitedProjectDto } from "../types";
import { cloneDeep } from "lodash";
import type { TableField } from "bootstrap-vue-next";

export default defineComponent({
  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();
    const notificationStore = useNotificationStore();

    return { projectStore, resourceStore, notificationStore };
  },

  data() {
    return {
      coscineResourceTypes: CoscineResourceTypes,
      selectedResourceTypeId: null as null | string,
      selectedQuotas: {} as ProjectQuotaDto | undefined,
      loadingData: false,
      storingQuota: false,
    };
  },

  computed: {
    isGuest(): boolean | undefined {
      return this.projectStore.currentUserRoleIsGuest;
    },
    isMember(): boolean | undefined {
      return this.projectStore.currentUserRoleIsMember;
    },
    project(): VisitedProjectDto | null {
      return this.projectStore.currentProject;
    },
    projects(): ProjectDto[] {
      return this.projectStore.allProjects ?? [];
    },
    resources(): ResourceDto[] | null | undefined {
      return this.project?.resources?.filter(
        (r) => r.type?.id === this.selectedResourceTypeId,
      );
    },
    resourceQuotaTableFields(): TableField<ResourceQuotaDto>[] {
      return [
        {
          key: "name",
          label: this.$t("page.quota.resourceName"),
          sortable: true,
          formatter: (_, __, item) =>
            this.resources?.find((r) => r.id === item.resource?.id)
              ?.displayName ?? "",
          sortByFormatted: true,
        },
        { key: "used", label: this.$t("page.quota.used"), sortable: true },
        {
          key: "reserved",
          label: this.$t("page.quota.reserved"),
          sortable: true,
        },
        { key: "adjust" },
      ];
    },
    resourceQuotas(): ResourceQuotaDto[] {
      return this.selectedQuotas?.resourceQuotas ?? [];
    },
    resourceTypesQuotas(): ProjectQuotaDto[] {
      return this.projectStore.currentResourceTypesQuotas ?? [];
    },
    resourceTypesInformation(): ExtendedResourceTypeInformationDto[] {
      const labeledResourceTypes: ExtendedResourceTypeInformationDto[] = [];
      const resourceTypes = this.resourceStore.enabledResourceTypes;
      if (resourceTypes) {
        resourceTypes.forEach((r) => {
          // Drop resource types with no quota available (e.g. Linked Data)
          if (r.isQuotaAvailable && r.isEnabled) {
            const labeledResourceType: ExtendedResourceTypeInformationDto = {
              iDisplayName: this.$t(
                "resourceTypes." + r.specificType + ".displayName",
              ).toString(),
            };
            Object.assign(labeledResourceType, r);
            labeledResourceTypes.push(labeledResourceType);
          }
        });
        return labeledResourceTypes.sort((a, b) => {
          const valueA = a.iDisplayName.toUpperCase();
          const valueB = b.iDisplayName.toUpperCase();
          return valueA < valueB ? -1 : valueA > valueB ? 1 : 0;
        });
      } else {
        return [];
      }
    },
    selectedResourceTypeInformation():
      | ExtendedResourceTypeInformationDto
      | undefined {
      return this.resourceTypesInformation?.find(
        (rt) => rt.id === this.selectedResourceTypeId,
      );
    },
  },

  watch: {
    selectedResourceTypeId() {
      // Triggered after selecting a new resource type from the dropdown
      this.cloneSelectedQuotas();
    },
    resourceTypesQuotas() {
      // Triggered after updating a single resource reserved quota
      this.cloneSelectedQuotas();
    },
    resourceTypesInformation() {
      this.selectFirstResourceType();
    },
  },

  async created() {
    this.loadingData = true;
    await this.fetchData();
    this.selectFirstResourceType();
    this.loadingData = false;
  },

  methods: {
    /**
     * Fetches necessary data if not already present.
     * @returns {Promise<void>} - A promise that resolves once the necessary data is fetched.
     */
    async fetchData(): Promise<void> {
      // Load Quotas for the project if not present
      if (this.projectStore.currentResourceTypesQuotas === null) {
        await this.projectStore.retrieveResourceTypeQuotas(this.project);
      }
    },

    /**
     * Updates the project's quota for the selected resource type.
     * @returns {Promise<void>} - A promise that resolves once the quota is updated.
     */
    async updateResourceTypeProjectQuota(): Promise<void> {
      if (
        this.project &&
        this.selectedResourceTypeInformation &&
        this.selectedQuotas?.allocated
      ) {
        this.storingQuota = true;

        const projectQuotaForUpdate: ProjectQuotaForUpdateDto = {
          allocated: {
            value: this.toGiB(this.selectedQuotas.allocated),
            unit: QuotaUnit.GibiByte,
          },
        };

        const success = await this.projectStore.updateResourceTypeProjectQuota(
          this.project,
          this.selectedResourceTypeInformation,
          projectQuotaForUpdate,
        );
        if (success) {
          // On Success
          // Refresh the quota information in the store
          await this.projectStore.retrieveResourceTypeQuotas(this.project);
          this.notificationStore.postNotification({
            title: this.$t(
              "page.quota.resourceTypeQuotaChangedSuccessTitle",
            ).toString(),
            body: this.$t("page.quota.resourceTypeQuotaChangedSuccessBody", {
              ProjectName: this.project.displayName,
              AmountInGB: this.toGiB(this.selectedQuotas.allocated),
            }).toString(),
          });
        } else {
          // On Failure
          this.notificationStore.postNotification({
            title: this.$t(
              "page.quota.resourceTypeQuotaChangedFailureTitle",
            ).toString(),
            body: this.$t(
              "page.quota.resourceTypeQuotaChangedFailureBody",
            ).toString(),
            variant: "warning",
          });
        }
        this.storingQuota = false;
      }
    },

    /**
     * Updates the quota for a specific resource.
     * @param {ResourceQuotaDto} resourceQuotaDto - The resource quota DTO containing the updated quota information.
     * @returns {Promise<void>} - A promise that resolves once the quota is updated.
     */
    async updateResourceQuota(
      resourceQuotaDto: ResourceQuotaDto,
    ): Promise<void> {
      if (
        this.project?.id &&
        resourceQuotaDto.resource?.id &&
        resourceQuotaDto.reserved?.value &&
        resourceQuotaDto.reserved?.unit
      ) {
        this.storingQuota = true;

        const desiredReservedResourceQuota: QuotaForManipulationDto = {
          value: resourceQuotaDto.reserved.value,
          unit: resourceQuotaDto.reserved.unit,
        };

        const success = await this.projectStore.updateResourceQuota(
          this.project.id,
          resourceQuotaDto?.resource.id,
          desiredReservedResourceQuota,
        );

        if (success) {
          // On Success
          // Refresh the quota information in the store
          await this.projectStore.retrieveResourceTypeQuotas(this.project);
          this.notificationStore.postNotification({
            title: this.$t(
              "page.quota.resourceQuotaChangedSuccessTitle",
            ).toString(),
            body: this.$t("page.quota.resourceQuotaChangedSuccessBody", {
              ResourceName: this.resources?.find(
                (r) => r.id === resourceQuotaDto.resource?.id,
              )?.displayName,
              AmountInGB: this.toGiB(resourceQuotaDto.reserved),
            }).toString(),
          });
        } else {
          // On Failure
          this.notificationStore.postNotification({
            title: this.$t(
              "page.quota.resourceQuotaChangedFailureTitle",
            ).toString(),
            body: this.$t(
              "page.quota.resourceQuotaChangedFailureBody",
            ).toString(),
            variant: "warning",
          });
        }
        this.storingQuota = false;
      }
    },

    /**
     * Selects the first resource type if no resource type is currently selected.
     */
    selectFirstResourceType(): void {
      if (
        !this.selectedResourceTypeId &&
        this.resourceTypesInformation &&
        this.resourceTypesInformation.length > 0 &&
        this.resourceTypesInformation[0].id
      ) {
        this.selectedResourceTypeId = this.resourceTypesInformation[0].id;
      }
    },

    /**
     * Converts a quota value to GiB (Gibibytes).
     * @param quota - The quota to be converted.
     * @returns {number} - The quota value in GiB.
     */
    toGiB(quota: QuotaDto | null | undefined): number {
      // Almost all displayed values inside the html must be shown in GiB, making this method necessary to ensure that's always the case.
      return quota
        ? FileUtil.convertCapacityUnits(quota, QuotaUnit.GibiByte)
        : 0;
    },

    /**
     * Formats the used quota value for display.
     * @param quota - The quota to be formatted.
     * @returns The formatted used quota value.
     */
    formatUsed(quota: QuotaDto | undefined): string {
      if (quota === undefined) {
        quota = {
          unit: QuotaUnit.Byte,
          value: 0,
        };
      }
      return FileUtil.formatBytes(
        FileUtil.convertCapacityUnits(quota, QuotaUnit.Byte),
      );
    },

    /**
     * Calculates the minimum quota value in GiB for the specified resource.
     * @param resourceId - The ID of the resource.
     * @returns The minimum quota value in GiB.
     */
    minGiB(resourceId: string | undefined): number {
      // To get the used quota, use the information in the store.
      const resourceQuota = this.resourceTypesQuotas
        ?.find((rtq) => rtq.resourceType?.id === this.selectedResourceTypeId)
        ?.resourceQuotas?.find((rq) => rq.resource?.id === resourceId);
      const usedQuotaInGiB = this.toGiB(resourceQuota?.used);

      return Math.ceil(usedQuotaInGiB || 1);
    },

    /**
     * Calculates the maximum quota value in GiB for the specified resource.
     * @param resourceId - The ID of the resource.
     * @returns The maximum quota value in GiB.
     */
    maxGiB(resourceId: string | undefined): number {
      // To get the reserved quota, use the information in the store.
      // IMPORTANT: Read the summary above cloneSelectedQuotas.
      // If done differently this method breaks and the slider can increase infinitely.
      const resourceQuota = this.resourceTypesQuotas
        ?.find((rtq) => rtq.resourceType?.id === this.selectedResourceTypeId)
        ?.resourceQuotas?.find((rq) => rq.resource?.id === resourceId);
      // Read the current reserved quota in the store
      const reservedQuotaInGiB = this.toGiB(resourceQuota?.reserved);
      // Calculate the free quota available for increasing this resource's reserved quota
      const freeQuotaGiB =
        this.toGiB(this.selectedQuotas?.allocated) -
        this.toGiB(this.selectedQuotas?.totalReserved);
      // Calculate the maximum quota available for increasing
      return reservedQuotaInGiB + freeQuotaGiB;
    },

    /**
     * Creates a deep copy of the selected quota.
     *
     * We use `cloneDeep` because a simple assignment would copy the nested objects by reference,
     * not by value. Thus, modifying `this.selectedQuotas` would also modify the original object
     * in `this.resourceTypesQuotas`. Refer to the usage inside v-model in the slider.
     * Alternatively use: <target> = JSON.parse(JSON.stringify(<source>));
     */
    cloneSelectedQuotas() {
      this.selectedQuotas = cloneDeep(
        this.resourceTypesQuotas?.find(
          (rtq) => rtq.resourceType?.id === this.selectedResourceTypeId,
        ),
      );
    },

    /**
     * Checks if a resource with the given ID is archived.
     *
     * @param {string} resourceId - The ID of the resource to check.
     * @returns {boolean} - A boolean value indicating whether the resource is archived.
     */
    isArchived(resourceId?: string): boolean {
      return (
        this.resources?.find((r) => r.id === resourceId)?.archived ?? false
      );
    },
  },
});
</script>

<style scoped>
.list-group {
  width: 20%;
}
.resourceQuotaSlider {
  width: calc(100% - 8em);
  padding-top: 0.9rem;
}
#quotaManagement :deep(.b-table-empty-row) {
  background-color: #f5f5f5;
}
.rangeVisual {
  margin-top: -0.3rem;
}
#label.text-break {
  font-weight: bold;
}
#projectQuotaSlider {
  border-radius: 1px;
  border-left-width: 1px;
  border-right-width: 1px;
  border-top-width: 1px;
  border-bottom-width: 1px;
  height: 38px;
  padding-left: 10px;
  padding-right: 10px;
}
</style>
